//
//  GuesstureViewController.m
//  Guessture
//
//  Created by Brandon Trebitowski on 3/16/10.
//  Copyright RightSprite 2010. All rights reserved.
//

#import "GuesstureViewController.h"

@implementation GuesstureViewController

@synthesize imageView;

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if ((self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil])) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	UITapGestureRecognizer *singleFingerTap = [[UITapGestureRecognizer alloc]
											   initWithTarget:self action:@selector(handleSingleTap:)];
    singleFingerTap.numberOfTapsRequired = 1;
    [self.view addGestureRecognizer:singleFingerTap];
    [singleFingerTap release];
	
    UIPanGestureRecognizer *panGesture = [[UIPanGestureRecognizer alloc]
										  initWithTarget:self action:@selector(handlePanGesture:)];
    [self.view addGestureRecognizer:panGesture];
    [panGesture release];
	
    UIPinchGestureRecognizer *pinchGesture = [[UIPinchGestureRecognizer alloc]
											  initWithTarget:self action:@selector(handlePinchGesture:)];
    [self.view addGestureRecognizer:pinchGesture];
    [pinchGesture release];
	
	UIRotationGestureRecognizer *rotationGesture = [[UIRotationGestureRecognizer alloc]
													initWithTarget:self action:@selector(handleRotationGesture:)];
	[self.view addGestureRecognizer:rotationGesture];
	[rotationGesture release];
	
}

- (IBAction)handleRotationGesture:(UIRotationGestureRecognizer *)sender {
	CGFloat rotation = [sender rotation];
    self.imageView.transform = CGAffineTransformMakeRotation(rotation);
}

- (IBAction)handlePinchGesture:(UIGestureRecognizer *)sender {
    CGFloat factor = [(UIPinchGestureRecognizer *)sender scale];
    self.imageView.transform = CGAffineTransformMakeScale(factor, factor);
}

- (IBAction)handlePanGesture:(UIPanGestureRecognizer *)sender {
	CGPoint translate = [sender translationInView:self.view];
	
    CGRect newFrame = imageView.frame;
    newFrame.origin.x += translate.x / 2;
    newFrame.origin.y += translate.y / 2;
    imageView.frame = newFrame;
	
    if (sender.state == UIGestureRecognizerStateEnded)
        imageView.frame = newFrame;
}

- (IBAction)handleSingleTap:(UIGestureRecognizer *)sender {
    CGPoint tapPoint = [sender locationInView:sender.view];
    [UIView beginAnimations:nil context:NULL];
    imageView.center = tapPoint;
    [UIView commitAnimations];
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    return YES;
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	self.imageView = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
