//
//  eventreporterAppDelegate.m
//  eventreporter
//
//  Created by Shannon Appelcline on 7/8/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "eventreporterViewController.h"

@implementation eventreporterViewController

/*
 Implement loadView if you want to create a view hierarchy programmatically
- (void)loadView {
}
 */

- (IBAction)resetPage:(id)sender {

	startField.text = @"Begin: 159,230";
	startField.center = CGPointMake(159,230);

	endField.text = @"Begin: 159,230";
	endField.center = CGPointMake(159,230);

	bottomLabel.text = [NSString string];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}

- (void)manageTouches:(NSSet *)touches {

	for (UITouch *touch in touches) {
		if (touch.phase == UITouchPhaseBegan) {
			CGPoint touchPos = [touch locationInView:self.view];
			startField.center = touchPos;
			startField.text = [NSString stringWithFormat:@"Begin: %3.0f,%3.0f",touchPos.x,touchPos.y];
		} else if (touch.phase == UITouchPhaseMoved) {
			bottomLabel.text = @"  Touch is moving ...";
		} else if (touch.phase == UITouchPhaseEnded) {
			if (touch.tapCount > 1) {
				bottomLabel.text = [NSString stringWithFormat:@"  Taps: %2i",touch.tapCount];
			} else {
				bottomLabel.text = [NSString string];
			}
			CGPoint touchPos = [touch locationInView:self.view];
			endField.center = touchPos;
			endField.text = [NSString stringWithFormat:@"End: %3.0f,%3.0f",touchPos.x,touchPos.y];
		}
	}
}

- (void)dealloc {
	[startField release];
	[endField release];
	[bottomLabel release];
	[super dealloc];
}

@end
