//
//  RootViewController.m
//  navex
//
//  Created by Shannon Appelcline on 7/10/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "RootViewController.h"
#import "navexAppDelegate.h"


@implementation RootViewController


- (id)initWithCoder:(NSCoder *)decoder 

{
	
    self = [super initWithCoder:decoder];
	
    if (self) {
		
        self.title = @"Color List";
		
		colorList = [NSArray arrayWithObjects:
					 [NSDictionary dictionaryWithObjectsAndKeys:
					  @"Red",@"titleValue",
					  [UIColor redColor],@"colorValue",nil],
					 [NSDictionary dictionaryWithObjectsAndKeys:
					  @"Green",@"titleValue",
					  [UIColor greenColor],@"colorValue",nil],
					 [NSDictionary dictionaryWithObjectsAndKeys:
					  @"Blue",@"titleValue",
					  [UIColor blueColor],@"colorValue",nil],
					 nil];	
		
		self.navigationItem.rightBarButtonItem = 
		[[UIBarButtonItem alloc] 
		 initWithBarButtonSystemItem:UIBarButtonSystemItemAdd 
		 target:self action:@selector(changeTitle)];
    }
	
	[colorList retain];
	
    return self;
	
}

- (void)changeTitle {
	
	self.title = @"Clicked Colors";
	
}

- (void)viewDidLoad {
	// Add the following line if you want the list to be editable
	// self.navigationItem.leftBarButtonItem = self.editButtonItem;
}


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	
	
	
	return 1;
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return [colorList count];
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
	static NSString *MyIdentifier = @"MyIdentifier";
	
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:MyIdentifier];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:MyIdentifier] autorelease];
	}
	
	cell.textLabel.text = [[colorList objectAtIndex:indexPath.row] objectForKey:@"titleValue"];
	cell.textLabel.textColor = [[colorList objectAtIndex:indexPath.row] objectForKey:@"colorValue"];	
	cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
	
	return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	
	UIViewController *colorController = [[UIViewController alloc] init];
	colorController.title = 
	[[tableView cellForRowAtIndexPath:indexPath] textLabel].text;
	
	colorController.view  = [[UIView alloc] init];
	colorController.view.backgroundColor = 
	[[tableView cellForRowAtIndexPath:indexPath] textLabel].textColor;
	
	[self.navigationController 
	 pushViewController:colorController animated:YES];	
	
	[colorController release];
}


/*
 Override if you support editing the list
 - (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
 
 if (editingStyle == UITableViewCellEditingStyleDelete) {
 // Delete the row from the data source
 [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
 }	
 if (editingStyle == UITableViewCellEditingStyleInsert) {
 // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
 }	
 }
 */


/*
 Override if you support conditional editing of the list
 - (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
 // Return NO if you do not want the specified item to be editable.
 return YES;
 }
 */


/*
 Override if you support rearranging the list
 - (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
 }
 */


/*
 Override if you support conditional rearranging of the list
 - (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
 // Return NO if you do not want the item to be re-orderable.
 return YES;
 }
 */ 


- (void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated {
	[super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated {
}

- (void)viewDidDisappear:(BOOL)animated {
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[super dealloc];
	[colorList release];
}

@end

