//
//  contactsearchAppDelegate.m
//  contactsearch
//
//  Created by Shannon Appelcline on 9/12/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "contactsearchViewController.h"

@implementation contactsearchViewController

- (void)searchBarSearchButtonClicked:(UISearchBar *)searchBar {

	[searchBar resignFirstResponder];
	ABAddressBookRef addressBook = ABAddressBookCreate();
	
	CFIndex abPCount = ABAddressBookGetPersonCount(addressBook);
	CFIndex abGCount = ABAddressBookGetGroupCount(addressBook);

	CFArrayRef searchResults = ABAddressBookCopyPeopleWithName(addressBook, (CFStringRef)searchBar.text);

	myText.text = [NSString stringWithString:@"Possible Completions:"];

	for (int i=0; i < CFArrayGetCount(searchResults); i++) {
		ABRecordRef thisPerson = CFArrayGetValueAtIndex(searchResults, i);
		myText.text = [myText.text stringByAppendingFormat:@"\n\n%@",
					   (NSString *)ABRecordCopyCompositeName(thisPerson)];

		CFStringRef thisJob = ABRecordCopyValue(thisPerson, kABPersonJobTitleProperty);
		CFStringRef thisOrg = ABRecordCopyValue(thisPerson, kABPersonOrganizationProperty);

		if (thisJob != NULL && thisOrg != NULL) {
			myText.text = [myText.text stringByAppendingFormat:@"\n%@ of %@",thisJob,thisOrg];
		}
		
		ABMultiValueRef thisPhones = ABRecordCopyValue(thisPerson, kABPersonPhoneProperty);
		if (thisPhones != NULL) {
			for (int j = 0; j < ABMultiValueGetCount(thisPhones) ; j++) {
				myText.text = [myText.text stringByAppendingFormat:@"\n%@: %@",
					(NSString *)ABMultiValueCopyLabelAtIndex(thisPhones, j),
					(NSString *)ABMultiValueCopyValueAtIndex(thisPhones, j)];
			}
		}
	}
	myText.text = [myText.text stringByAppendingFormat:@"\n\nThere are %ld records and %ld groups in this address book.",abPCount,abGCount];

	CFRelease(searchResults);
	CFRelease(addressBook);
		
}

/*
 Implement loadView if you want to create a view hierarchy programmatically
- (void)loadView {
}
 */

/*
 Implement viewDidLoad if you need to do additional setup after loading the view.
- (void)viewDidLoad {
	[super viewDidLoad];
}
 */


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[super dealloc];
}

@end
