//
//  contactselectAppDelegate.m
//  contactselect
//
//  Created by Shannon Appelcline on 9/12/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "contactselectViewController.h"

@implementation contactselectViewController

-(IBAction)selectContact:(id)sender {

	ABPeoplePickerNavigationController *myPicker =
		[[ABPeoplePickerNavigationController alloc] init];
	
    myPicker.peoplePickerDelegate = self;
		
    [self presentModalViewController:myPicker animated:YES];
	
    [myPicker release];
}

- (BOOL)peoplePickerNavigationController:(ABPeoplePickerNavigationController *)peoplePicker shouldContinueAfterSelectingPerson:(ABRecordRef)thisPerson {

	CFIndex abPCount = ABAddressBookGetPersonCount(peoplePicker.addressBook);
	CFIndex abGCount = ABAddressBookGetGroupCount(peoplePicker.addressBook);

	myText.text = [NSString stringWithString:@"Selected Contact:"];
	
	myText.text = [myText.text stringByAppendingFormat:@"\n\n%@",
	        (NSString *)ABRecordCopyCompositeName(thisPerson)];
		
	CFStringRef thisJob = ABRecordCopyValue(thisPerson, kABPersonJobTitleProperty);
	CFStringRef thisOrg = ABRecordCopyValue(thisPerson, kABPersonOrganizationProperty);
		
	if (thisJob != NULL && thisOrg != NULL) {
	    myText.text = [myText.text stringByAppendingFormat:@"\n%@ of %@",thisJob,thisOrg];
	}
		
	ABMultiValueRef thisPhones = ABRecordCopyValue(thisPerson, kABPersonPhoneProperty);
	if (thisPhones != NULL) {
		for (int j = 0; j < ABMultiValueGetCount(thisPhones) ; j++) {
			myText.text = [myText.text stringByAppendingFormat:@"\n%@: %@",
			    (NSString *)ABMultiValueCopyLabelAtIndex(thisPhones, j),
				(NSString *)ABMultiValueCopyValueAtIndex(thisPhones, j)];
		}
	}

	myText.text = [myText.text stringByAppendingFormat:@"\n\nThere are %ld records and %ld groups in this address book.",abPCount,abGCount];
	
	[self dismissModalViewControllerAnimated:YES];

	return NO;
}

- (BOOL)peoplePickerNavigationController:(ABPeoplePickerNavigationController *)peoplePicker shouldContinueAfterSelectingPerson:(ABRecordRef)person property:(ABPropertyID)property identifier:(ABMultiValueIdentifier)identifier {	

	return NO;	
}

- (void)peoplePickerNavigationControllerDidCancel:(ABPeoplePickerNavigationController *)peoplePicker {

	[self dismissModalViewControllerAnimated:YES];
	
}

-(IBAction)newContact:(id)sender {

	ABNewPersonViewController *myAdder =
		[[ABNewPersonViewController alloc] init];
    myAdder.newPersonViewDelegate = self;

	UINavigationController *myNav = [[UINavigationController alloc] initWithRootViewController:myAdder];
	[self presentModalViewController:myNav animated:YES];
	
    [myAdder release];
	[myNav release];
}

- (void)newPersonViewController:(ABNewPersonViewController *)newPersonViewController didCompleteWithNewPerson:(ABRecordRef)person {

	[self dismissModalViewControllerAnimated:YES];
}

/*
 Implement loadView if you want to create a view hierarchy programmatically
- (void)loadView {
}
 */

/*
 Implement viewDidLoad if you need to do additional setup after loading the view.
- (void)viewDidLoad {
	[super viewDidLoad];
}
 */


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[super dealloc];
}

@end
