//
//  filesaverAppDelegate.m
//  filesaver
//
//  Created by Shannon Appelcline on 9/9/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "filesaverViewController.h"

@implementation filesaverViewController

- (void)viewDidLoad {
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, 
														 NSUserDomainMask, YES);
	NSString *documentsDirectory = [paths objectAtIndex:0];
    filePath = [documentsDirectory 
				stringByAppendingPathComponent:@"textviewcontent"];
	
	[filePath retain];
	
	NSFileManager *myFM = [NSFileManager defaultManager];
	
	if ([myFM isReadableFileAtPath:filePath]) {
		myText.text = [NSString stringWithContentsOfFile:filePath encoding:NSASCIIStringEncoding error:nil];
	}
	
	keyboardIsActive = NO;
	
	[super viewDidLoad];
}

-(IBAction)finishEditing:(id)sender {

	if (keyboardIsActive == YES) {
		[myText resignFirstResponder];
	} else {
		exit(0);
	}
}

- (void)textViewDidBeginEditing:(UITextView *)textView {

	if ([myText.text compare:@"Type Text Here."] == NSOrderedSame) {
		myText.text = [NSString string];
	}
	keyboardIsActive = YES;
}

- (void)textViewDidEndEditing:(UITextView *)textView {
		
	[textView.text writeToFile:filePath atomically:YES encoding:NSASCIIStringEncoding error:NULL];
	keyboardIsActive = NO;
	
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[filePath release];
	[super dealloc];
}

@end
