//
//  PreferencesController.m
//  selfpreferences
//
//  Created by Shannon Appelcline on 8/19/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "PreferencesController.h"


@implementation PreferencesController


- (id)initWithStyle:(UITableViewStyle)style {
	if (self = [super initWithStyle:style]) {
		
		NSUserDefaults *myDefaults = [NSUserDefaults standardUserDefaults];		
		
		settingsList = [NSArray arrayWithObjects:
					[NSMutableDictionary dictionaryWithObjectsAndKeys:
					 @"Sounds",@"titleValue",	
					 @"switch",@"accessoryValue",
					 [NSNumber numberWithBool:[myDefaults boolForKey:@"soundsValue"]],@"prefValue",
					 @"setSounds:",@"targetValue",nil],
					[NSMutableDictionary dictionaryWithObjectsAndKeys:
					 @"Music",@"titleValue",	
					 @"switch",@"accessoryValue",
					 [NSNumber numberWithBool:[myDefaults boolForKey:@"musicValue"]],@"prefValue",
					 @"setMusic:",@"targetValue",nil],nil];

		 
		[settingsList retain];

		CGPoint tableCenter = self.view.center;
		self.view.center = CGPointMake(tableCenter.x,tableCenter.y+22);

		switchList = [NSMutableArray arrayWithCapacity:settingsList.count];
		for (int i = 0 ; i < [settingsList count] ; i++) {
			if ([[[settingsList objectAtIndex:i] objectForKey:@"accessoryValue"] compare:@"switch"] == NSOrderedSame) {
				UISwitch *mySwitch = [[[UISwitch alloc] initWithFrame:CGRectZero] autorelease];
				mySwitch.on = [[[settingsList objectAtIndex:i] objectForKey:@"prefValue"] boolValue];
				[mySwitch addTarget:self action:NSSelectorFromString([[settingsList objectAtIndex:i] objectForKey:@"targetValue"]) forControlEvents:UIControlEventValueChanged];
				[switchList insertObject:mySwitch atIndex:i];
			} else {
				[switchList insertObject:@"" atIndex:i];
			}
		}
		
		[switchList retain];
	}

	return self;
}


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	return 1;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {

	return @"Audio Preferences";
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return settingsList.count;
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
	
	static NSString *MyIdentifier = @"MyIdentifier";
	
	UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:MyIdentifier];
	if (cell == nil) {
		cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:MyIdentifier] autorelease];
	}
	cell.textLabel.text = [[settingsList objectAtIndex:indexPath.row] objectForKey:@"titleValue"];
	if ([switchList objectAtIndex:indexPath.row]) {
		cell.accessoryView = [switchList objectAtIndex:indexPath.row];
	}
	
	return cell;
}

-(void)setMusic:(id)sender {
		
	NSUserDefaults *myDefaults = [NSUserDefaults standardUserDefaults];		
	UISwitch *musicSwitch = [switchList objectAtIndex:1];
	
    [myDefaults setBool:musicSwitch.on forKey:@"musicValue"];
	[NSUserDefaults resetStandardUserDefaults];
	
}

-(void)setSounds:(id)sender {

	NSUserDefaults *myDefaults = [NSUserDefaults standardUserDefaults];		
	UISwitch *soundsSwitch = [switchList objectAtIndex:0];
	
    [myDefaults setBool:soundsSwitch.on forKey:@"soundsValue"];
	[NSUserDefaults resetStandardUserDefaults];
	
}

/*
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
}
*/
/*
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
	
	if (editingStyle == UITableViewCellEditingStyleDelete) {
	}
	if (editingStyle == UITableViewCellEditingStyleInsert) {
	}
}
*/
/*
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
	return YES;
}
*/
/*
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/
/*
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
	return YES;
}
*/


- (void)dealloc {
	
	[settingsList release];
	[switchList release];
	[super dealloc];
}


- (void)viewDidLoad {
	[super viewDidLoad];
}


- (void)viewWillAppear:(BOOL)animated {
	[super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated {
	[super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated {
}

- (void)viewDidDisappear:(BOOL)animated {
}

- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning];
}


@end

