//
//  AddEntryViewController.m
//  CDJournal
//
//  Created by Brandon Trebitowski on 11/2/09.
//  Copyright 2009 RightSprite. All rights reserved.
//

#import "AddEntryViewController.h"
#import "Entry.h"

@implementation AddEntryViewController

@synthesize textField;
@synthesize textView;
@synthesize entry;
@synthesize managedObjectContext;

- (IBAction)cancel:(id) sender {
	[self.parentViewController dismissModalViewControllerAnimated:YES];
}

- (IBAction)done:(id) sender {
	if([textView isFirstResponder]) {
		[textView resignFirstResponder];
	} else if([textField isFirstResponder]) {
		[textField resignFirstResponder];
	} else { 
		[self save:self];
	}
}

- (IBAction) save:(id) sender {
	NSLog(@"SAVE");
	if(self.entry) {
		[self.entry setTitle:textField.text];
		[self.entry setBody:textView.text];
		[self.entry setCreationDate:[NSDate date]];
		
		NSError *error;
		if (![managedObjectContext save:&error]) {
			NSLog(@"Error Saving: %@",[error description]);
		}
		
		[self.navigationController popViewControllerAnimated:YES];
	} else {
		Entry * e = (Entry *)[NSEntityDescription insertNewObjectForEntityForName:@"Entry" inManagedObjectContext:managedObjectContext];
		[e setTitle:textField.text];
		[e setBody:textView.text];
		[e setCreationDate:[NSDate date]];
		NSError *error;
		if (![managedObjectContext save:&error]) {
			NSLog(@"Error Saving: %@",[error description]);
		}
		[self.parentViewController dismissModalViewControllerAnimated:YES];
	}
	
	
	
}

#pragma mark textfield methods

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
	[self.textField resignFirstResponder];
	return YES;
}

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void) viewDidAppear: (BOOL) animated {
	if(self.entry) {
		[textField setText:[entry title]];
		[textView setText:[entry body]];
	}
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


@end
