//
//  SKMenu.m
//  dbnav
//
//  Created by Shannon Appelcline on 9/11/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "SKMenu.h"

@implementation SKMenu

- (id)initWithFile:(NSString *)dbFile {
	
	self = [super init];
	
	myDB = [[SKDatabase alloc] initWithFile:dbFile];
	
	return self;
}

- (int)countForMenuWithParent:(int)parentid {
	
	int resultCount = 0;
	
	NSString *sql = [NSString stringWithFormat:@"SELECT COUNT(*) FROM menu WHERE parentid=%i",parentid];
	
	resultCount = (int)[myDB lookupSingularSQL:sql forType:@"integer"];
	
	return resultCount;
}

- (id)contentForMenuWithParent:(int)parentid Row:(int)row content:(NSString *)contenttype {
	
	NSString *sql = [NSString stringWithFormat:@"SELECT %@ FROM menu WHERE parentid=%i AND ordering=%i",contenttype,parentid,row];
    return [myDB lookupSingularSQL:sql forType:@"text"];
	
}

- (int)integerForMenuWithParent:(int)parentid Row:(int)row content:(NSString *)contenttype {
	
	NSString *sql = [NSString stringWithFormat:@"SELECT %@ FROM menu WHERE parentid=%i AND ordering=%i",contenttype,parentid,row];
    return (int)[myDB lookupSingularSQL:sql forType:@"integer"];
	
}

- (void)dealloc {
	
	[myDB close];
	[myDB release];
	
	[super dealloc];
	
}
@end
