//
//  altitudeAppDelegate.m
//  altitude
//
//  Created by Shannon Appelcline on 9/8/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "altitudeViewController.h"
#import "CoreLocation/CLLocation.h"
#import "CoreLocation/CLLocationManager.h"

@implementation altitudeViewController

- (void)viewDidLoad {

	destinationHeight.returnKeyType = UIReturnKeyDone;

	myLM = [[CLLocationManager alloc] init];
	myLM.delegate = self;
	myLM.desiredAccuracy = kCLLocationAccuracyBest;
	
	savedDestinationHeight = 0;

	[super viewDidLoad];
}

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
	[textField resignFirstResponder];
	return YES;
}

-(IBAction)changeDestination:(id)sender {
	
	savedDestinationHeight = [destinationHeight.text intValue];
	[self resetGPS:sender];
	
}

-(IBAction)resetGPS:(id)sender {

	if (savedDestinationHeight) {
		[myLM startUpdatingLocation];
		[myActivity startAnimating];
	}
}

- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation {

	if (savedDestinationHeight) {
		if (signbit(newLocation.verticalAccuracy)) {
			heightLabel.text = [NSString stringWithString:@"?? m."];
		} else {
			int currentHeight = 395 - ceil((float)newLocation.altitude/savedDestinationHeight * (401-65));

			heightLabel.text = [NSString stringWithFormat:@"%6.2f m.",newLocation.altitude];

			heightButton.center = CGPointMake(176,currentHeight);
			heightLabel.center = CGPointMake(220,currentHeight);
		}
		[myLM stopUpdatingLocation];
		[myActivity stopAnimating];

	}

}



- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[super dealloc];
	[myLM release];
}

@end
