//
//  distanceAppDelegate.m
//  distance
//
//  Created by Shannon Appelcline on 8/22/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "distanceViewController.h"
#import "CoreLocation/CLLocation.h"
#import "CoreLocation/CLLocationManager.h"

@implementation distanceViewController
/*
 Implement loadView if you want to create a view hierarchy programmatically
- (void)loadView {
}
 */

- (void)viewDidLoad {

	[super viewDidLoad];

	myLM = [[CLLocationManager alloc] init];
	myLM.delegate = self;
	myLM.desiredAccuracy = kCLLocationAccuracyNearestTenMeters;
	myLM.distanceFilter = 100;
	
	[myLM startUpdatingLocation];

}

- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation {
	
	
	if (startLoc == nil) {
		startLoc = newLocation;
		[self updateLocationFor:startLabel toLocation:newLocation];
		[startLoc retain];
		
	}
	
	[self updateLocationFor:endLabel toLocation:newLocation];
	[self updateDistanceLabel:newLocation];
	
}

- (IBAction)setEnd:(id)sender {

	[myLM stopUpdatingLocation];
	[myLM startUpdatingLocation];
	
}

- (IBAction)controlChange:(id)sender {

	if (myLM.location) {
		[self updateDistanceLabel:myLM.location];
	}
}

- (void)updateDistanceLabel:(CLLocation *)newLocation {
	if (startLoc != nil) {
		CLLocationDistance traveled = [startLoc getDistanceFrom:newLocation] / 1000;

		if (segmentControl.selectedSegmentIndex == 1) {
	
			traveled *= .62;
		}

		distanceLabel.text = [NSString stringWithFormat:@"%5.1f",traveled];
	}
	
}

- (void)updateLocationFor:(UILabel *)thisLabel toLocation:(CLLocation *)newLocation {

	CLLocationCoordinate2D curCoords = newLocation.coordinate;
	thisLabel.text = [NSString stringWithFormat:@"Lat: %2.4f; Long: %2.4f",curCoords.latitude,curCoords.longitude];
		
}




- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[super dealloc];
}

@end
