//
//  gravityAppDelegate.m
//  gravity
//
//  Created by Shannon Appelcline on 7/15/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "gravityViewController.h"
#define kFilteringFactor 0.1

@implementation gravityViewController
@synthesize redBall;

/*
 Implement loadView if you want to create a view hierarchy programmatically
- (void)loadView {
}
 */

- (void)viewDidLoad {
	UIAccelerometer *myAccel = [UIAccelerometer sharedAccelerometer];
	myAccel.updateInterval = .01;
	myAccel.delegate = self;
	
	[super viewDidLoad];
}

- (void)accelerometer:(UIAccelerometer *)accelerometer didAccelerate:(UIAcceleration *)acceleration {

	CGPoint curCenter = [redBall center];

	gravX = (acceleration.x * kFilteringFactor)
		+ (gravX * (1 - kFilteringFactor));
	gravY = (acceleration.y * kFilteringFactor)
	    + (gravY * (1 - kFilteringFactor));
	
	float newX = 3 * gravX + curCenter.x;
	float newY = -3 * gravY + curCenter.y;

	if (newX < 25) newX = 25;
	if (newY < 25) newY = 25;
	if (newX > 295) newX = 295;
	if (newY > 435)	newY = 435;
	
	redBall.center = CGPointMake(newX,newY);
	
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[super dealloc];
}

@end
