//
//  movementAppDelegate.m
//  movement
//
//  Created by Shannon Appelcline on 7/16/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "movementViewController.h"
#define kFilteringFactor 0.1

@implementation movementViewController
@synthesize myReport;

/*
 Implement loadView if you want to create a view hierarchy programmatically
- (void)loadView {
}
 */

- (void)viewDidLoad {
	
	UIAccelerometer *myAccel = [UIAccelerometer sharedAccelerometer];
	myAccel.updateInterval = .01;
	myAccel.delegate = self;
	
	accelX = 0;
	accelY = 0;
	accelZ = 0;
	moveVector = 0;
	
	[super viewDidLoad];
}

- (void)accelerometer:(UIAccelerometer *)accelerometer didAccelerate:(UIAcceleration *)acceleration {
		
	accelX = 
		((acceleration.x * kFilteringFactor)
		 + (accelX * (1 - kFilteringFactor)));
	accelY = 
		((acceleration.y * kFilteringFactor)
		+ (accelY * (1 - kFilteringFactor)));
	accelZ = 
		((acceleration.z * kFilteringFactor)
		 + (accelZ * (1 - kFilteringFactor)));

	float moveX = acceleration.x - accelX;
	float moveY = acceleration.y - accelY;
	float moveZ = acceleration.z - accelZ;
	
	if (!starttime) {
		starttime = acceleration.timestamp;
	}
		
	if (acceleration.timestamp > starttime + 1 &&
		(fabs(moveX) >= .1 ||
		 fabs(moveY) >= .1 ||
		 fabs(moveZ) >= .1)) {

		if (fabs(moveX) > fabs(moveVector)) {
			moveVector = moveX;
			moveDir = (moveVector > 0 ? @"Right" : @"Left");
		}
		if (fabs(moveY) > fabs(moveVector)) {
			moveVector = moveY;
			moveDir = (moveVector > 0 ? @"Up" : @"Down");
		}		
		if (fabs(moveZ) > fabs(moveVector)) {
			moveVector = moveZ;
			moveDir = (moveVector > 0 ? @"Forward" : @"Back");
		}
		lasttime = acceleration.timestamp;
	} else if (moveVector && acceleration.timestamp > lasttime + .1) {
		myReport.text = [moveDir stringByAppendingFormat:@": %f.",moveVector];
		moveDir = [NSString string];
		moveVector = 0;
	}
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[super dealloc];
}

@end
