//
//  shakeAppDelegate.m
//  shake
//
//  Created by Shannon Appelcline on 7/17/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "shakeViewController.h"
#define kFilteringFactor 0.1

@implementation shakeViewController

/*
 Implement loadView if you want to create a view hierarchy programmatically
- (void)loadView {
}
 */

- (void)viewDidLoad {
	
	colorArray = [NSArray arrayWithObjects:
		[UIColor greenColor],
		[UIColor yellowColor],
		[UIColor redColor],nil];
	
	colorCount = 0;
	colorMax = 3;
	
	self.view.backgroundColor = [colorArray objectAtIndex:colorCount];
	
	UIAccelerometer *myAccel = [UIAccelerometer sharedAccelerometer];
	myAccel.updateInterval = .01;
	myAccel.delegate = self;
	
	accelX = 0;
	accelY = 0;
	lastX = 0;
	lastY = 0;
	
	[colorArray retain];
	[super viewDidLoad];
}

- (void)accelerometer:(UIAccelerometer *)accelerometer didAccelerate:(UIAcceleration *)acceleration {

	if ([self didShake:(UIAcceleration *)acceleration]) {
		self.view.backgroundColor = [self nextColor];
	}
	
}

- (UIColor *)nextColor {

	colorCount = (colorCount + 1 ) % colorMax;
	return [colorArray objectAtIndex:colorCount];
	
}

- (BOOL)didShake:(UIAcceleration *)acceleration {

	accelX = 
	((acceleration.x * kFilteringFactor)
	 + (accelX * (1 - kFilteringFactor)));	
	
	float moveX = acceleration.x - accelX;
	
	accelY = 
	((acceleration.x * kFilteringFactor)
	 + (accelY * (1 - kFilteringFactor)));	
	
	float moveY = acceleration.x - accelY;
	
	if (lasttime && acceleration.timestamp > lasttime + .25) {
	
		BOOL result;
		
		if (shakecount >= 3 && biggestshake >= 1.25) {
			result = YES;
		} else {
			result = NO;
		}
		
		lasttime = 0;
		shakecount = 0;
		biggestshake = 0;
		
		return result;
		
	} else {
		if (fabs(moveX) >= fabs(moveY)) {
			if ((fabs(moveX) > .75) && (moveX * lastX <= 0)) {

				lasttime = acceleration.timestamp;
				shakecount++;
				lastX = moveX;
				if (fabs(moveX) > biggestshake) biggestshake = fabs(moveX);
			}
		} else {
			if ((fabs(moveY) > .75) && (moveY * lastY <= 0)) {

				lasttime = acceleration.timestamp;
				shakecount++;
				lastY = moveY;
				if (fabs(moveY) > biggestshake) biggestshake = fabs(moveY);
			}
		}
    	return NO;
	}
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
	// Return YES for supported orientations
	return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
	[super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
	// Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[colorArray release];
	[super dealloc];
}

@end
