//
//  RecordingTestViewController.m
//  RecordingTest
//
//  Created by Brandon Trebitowski on 8/24/09.
//  Copyright __MyCompanyName__ 2009. All rights reserved.
//

#import "RecordingTestViewController.h"

@implementation RecordingTestViewController

@synthesize recordBtn,soundRecorder;

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	recording = NO;
	NSString * filePath = [NSHomeDirectory()
						   stringByAppendingPathComponent:@"Documents/recording.caf"];
	
	NSDictionary *recordSettings = 
	[[NSDictionary alloc] initWithObjectsAndKeys:
	 [NSNumber numberWithFloat: 44100.0],AVSampleRateKey,
	 [NSNumber numberWithInt: kAudioFormatAppleLossless],    
	 AVFormatIDKey,
	 [NSNumber numberWithInt: 1],                         
	 AVNumberOfChannelsKey,
	 [NSNumber numberWithInt: AVAudioQualityMax],         
	 AVEncoderAudioQualityKey,nil];
	
	AVAudioRecorder *newRecorder = [[AVAudioRecorder alloc] 
									initWithURL: [NSURL fileURLWithPath:filePath]
									settings: recordSettings
									error: nil];
	
	[recordSettings release];
	self.soundRecorder = newRecorder;
	[newRecorder release];
	
	soundRecorder.delegate = self;
	
	
}

- (void)audioRecorderDidFinishRecording:(AVAudioRecorder *)recorder successfully:(BOOL)flag {
	NSLog(@"finished recording to %@",[[recorder url] description]);

}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (IBAction) record:(id) sender {
	
	if (recording) {
        [self.soundRecorder stop];
        recording = NO;		
    } else {
		[soundRecorder record];
		recording = YES;
		
    }
}


- (void)audioPlayerDecodeErrorDidOccur:(AVAudioPlayer *)player error:(NSError *)error {
	NSLog(@"Error %@",[error description]);
}

- (IBAction) play:(id) sender {
	NSString * filePath = [NSHomeDirectory()
						   stringByAppendingPathComponent:@"Documents/recording.caf"];
	
	AVAudioPlayer *newPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL: [NSURL fileURLWithPath:filePath] error: nil];
	newPlayer.delegate = self;
	NSLog(@"playing file at url %@ %d",[[newPlayer url] description],[newPlayer play]);
	
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
