//
//  drawView.m
//  photodraw
//
//  Created by Shannon Appelcline on 10/7/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "drawView.h"


@implementation drawView


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
    }
    return self;
}


-(void)drawPic:(UIImage *)thisPic {

	myPic = thisPic;

	[myPic retain];
	[self setNeedsDisplay];
}

- (void)drawRect:(CGRect)rect {

	float newHeight;
	float newWidth;
	
	if (!myDrawing) {
		myDrawing = [[NSMutableArray alloc] initWithCapacity:0];
	}
	CGContextRef ctx = UIGraphicsGetCurrentContext();
	
	if (myPic != NULL) {
		float ratio = myPic.size.height/460;
		if (myPic.size.width/320 > ratio) {
			ratio = myPic.size.width/320;
		}
		
		newHeight = myPic.size.height/ratio;
		newWidth = myPic.size.width/ratio;
	
		[myPic drawInRect:CGRectMake(0,0,newWidth,newHeight)];
	}
	if ([myDrawing count] > 0) {
		CGContextSetLineWidth(ctx, 5);

		for (int i = 0 ; i < [myDrawing count] ; i++) {
			NSArray *thisArray = [myDrawing objectAtIndex:i];
			
			if ([thisArray count] > 2) {
				float thisX = [[thisArray objectAtIndex:0] floatValue];
				float thisY = [[thisArray objectAtIndex:1] floatValue];

				CGContextBeginPath(ctx);
				CGContextMoveToPoint(ctx, thisX, thisY);

				for (int j = 2; j < [thisArray count] ; j+=2) {
					thisX = [[thisArray objectAtIndex:j] floatValue];
					thisY = [[thisArray objectAtIndex:j+1] floatValue];
		
					CGContextAddLineToPoint(ctx, thisX,thisY);
				}
				CGContextStrokePath(ctx);
			}
		}
	}
}

- (void) touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {

	[myDrawing addObject:[[NSMutableArray alloc] initWithCapacity:4]];
	
	CGPoint curPoint = [[touches anyObject] locationInView:self];
	[[myDrawing lastObject] addObject:[NSNumber numberWithFloat:curPoint.x]];
	[[myDrawing lastObject] addObject:[NSNumber numberWithFloat:curPoint.y]];
}

- (void) touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event {

	CGPoint curPoint = [[touches anyObject] locationInView:self];
	[[myDrawing lastObject] addObject:[NSNumber numberWithFloat:curPoint.x]];
	[[myDrawing lastObject] addObject:[NSNumber numberWithFloat:curPoint.y]];

	[self setNeedsDisplay];
}

- (void) touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event {

	CGPoint curPoint = [[touches anyObject] locationInView:self];
	[[myDrawing lastObject] addObject:[NSNumber numberWithFloat:curPoint.x]];
	[[myDrawing lastObject] addObject:[NSNumber numberWithFloat:curPoint.y]];

	[self setNeedsDisplay];

}

-(void)cancelDrawing {

	[myDrawing removeAllObjects];
	[self setNeedsDisplay];
	
}

- (void)dealloc {
    [super dealloc];
	[myPic release];
	[myDrawing release];
}


@end
