//
//  photodrawViewController.m
//  photodraw
//
//  Created by Shannon Appelcline on 10/7/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "photodrawViewController.h"
#import "drawView.h"

@implementation photodrawViewController



/*
// Override initWithNibName:bundle: to load the view using a nib file then perform additional customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically.
- (void)loadView {
}
*/


- (void)viewDidLoad {
    [super viewDidLoad];
	
	
}

-(IBAction)choosePic:(id)sender {

	UIImagePickerController *myImagePicker = [[UIImagePickerController alloc] init];
	myImagePicker.delegate = self;
	myImagePicker.allowsImageEditing = NO;
	
	[self presentModalViewController:myImagePicker animated:YES];	
	
}

- (void)imagePickerController:(UIImagePickerController *)picker didFinishPickingImage:(UIImage *)image editingInfo:(NSDictionary *)editingInfo {

	[self dismissModalViewControllerAnimated:YES];
	[picker release];

	[myTools setItems:[NSArray arrayWithObjects:
					   [[UIBarButtonItem alloc]
						initWithBarButtonSystemItem:UIBarButtonSystemItemSave
						target:self action:@selector(savePic:)],
					   [[UIBarButtonItem alloc]
						initWithBarButtonSystemItem:UIBarButtonSystemItemCancel
						target:self action:@selector(clearDrawing:)],
					   nil] animated:YES];	
	
	[self.view drawPic:image];

}

- (void)imagePickerControllerDidCancel:(UIImagePickerController *)picker {
	
	[self dismissModalViewControllerAnimated:YES];
	[picker release];
	
}

-(void)savePic:(id)sender {
	
	UIGraphicsBeginImageContext(self.view.bounds.size);
	[self.view.layer renderInContext:UIGraphicsGetCurrentContext()];
	[myTools removeFromSuperview];
	UIImage *finishedPic = UIGraphicsGetImageFromCurrentImageContext();
	UIGraphicsEndImageContext();
		
	UIImageWriteToSavedPhotosAlbum(finishedPic,self,@selector(exitProg:didFinishSavingWithError:contextInfo:),nil);
	
}

-(void)exitProg:(UIImage *)image didFinishSavingWithError:(NSError *)error contextInfo:(void *)contextInfo {
	
	exit(0);

}

-(void)clearDrawing:(id)sender {
	
	[self.view cancelDrawing];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
    [super dealloc];
}

@end
