//
//  drawView.m
//  quartz
//
//  Created by Shannon Appelcline on 9/25/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "drawView.h"


@implementation drawView


- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
        // Initialization code
    }
    return self;
}


- (void)drawRect:(CGRect)rect {

	CGMutablePathRef myPath = CGPathCreateMutable();

	CGPathAddArc(myPath,NULL,110,50,30,0,2*M_PI,1);
	CGPathMoveToPoint(myPath,NULL, 240, 50);
	CGPathAddArc(myPath,NULL,210,50,30,0,2*M_PI,1);
	CGPathAddArc(myPath,NULL,160,110,15,0,2*M_PI,1);
	CGPathAddArc(myPath,NULL,160,210,25,0,2*M_PI,1);
	
	CGContextRef ctx = UIGraphicsGetCurrentContext();

	CGContextSaveGState(ctx);
	CGContextBeginPath(ctx);
	CGContextAddArc(ctx,160,240,160,0,2*M_PI,1);
	CGContextClip(ctx);
	
	CGColorSpaceRef myColorSpace = CGColorSpaceCreateDeviceRGB();
	CGFloat components[12] = {1,0,0,1,
		0,1,0,1,
		0,0,1,1};
	CGFloat locations[3] = {0,.5,1};
	
	CGGradientRef myGradient = CGGradientCreateWithColorComponents(myColorSpace, 
																	components,
																	locations,
																	(size_t)3);
	CGContextDrawLinearGradient(ctx, myGradient, CGPointMake(0,0), CGPointMake(320,480), (CGGradientDrawingOptions)NULL);

	CGColorSpaceRelease(myColorSpace);
	CGGradientRelease(myGradient);
	
	CGContextBeginPath(ctx);

	CGContextSaveGState(ctx);

//	CGContextRotateCTM(ctx, .25*M_PI);
//	CGContextTranslateCTM(ctx, 100, 100);

	CGAffineTransform myAffine = CGAffineTransformMakeRotation(.25*M_PI);
	CGAffineTransformTranslate(myAffine, 100, 100);
	CGContextConcatCTM(ctx, myAffine);
	
    CGContextAddPath(ctx,myPath);
	
	CGContextStrokePath(ctx);
	CGContextRestoreGState(ctx);
	
	CGContextStrokeRect(ctx,CGRectMake(200, 300, 50, 50));
	
	CFRelease(myPath);

	CGContextRestoreGState(ctx);
    CGContextSelectFont (ctx, "Helvetica",20,kCGEncodingMacRoman);
	CGContextSetTextDrawingMode(ctx, kCGTextFill);
	CGAffineTransform flip = CGAffineTransformMake(1,0,0,-1,0,0);
    CGContextSetTextMatrix(ctx, flip);
	
	CGContextShowTextAtPoint(ctx, 20, 85, "A Quartz Example", 16); 
	
}


- (void)dealloc {
    [super dealloc];
}


@end
