//
//  geojsonViewController.m
//  geojson
//
//  Created by Shannon Appelcline on 10/21/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "geojsonViewController.h"

@implementation geojsonViewController



- (void)viewDidLoad {
    [super viewDidLoad];
	
	myLM = [[CLLocationManager alloc] init];
	myLM.delegate = self;
	myLM.desiredAccuracy = kCLLocationAccuracyHundredMeters;
	[myLM startUpdatingLocation];
	[myActivity startAnimating];
	
}

- (void)locationManager:(CLLocationManager *)manager didUpdateToLocation:(CLLocation *)newLocation fromLocation:(CLLocation *)oldLocation {
	[myLM stopUpdatingLocation];
	[myActivity stopAnimating];

	NSString *gnLookup = [NSString stringWithString:@"http://ws.geonames.org/findNearbyPostalCodesJSON?lat=37.331689&lng=-122.030731"];
	NSData *gnData = [NSData dataWithContentsOfURL:[NSURL URLWithString:gnLookup]];
	NSError *error = nil;
	NSDictionary *dictionary = [[CJSONDeserializer deserializer] deserializeAsDictionary:gnData error:&error];
	
	if(error) {
		postalLabel.text = [NSString stringWithFormat:@"Error: %@",[[error userInfo] objectForKey:@"NSLocalizedDescription"]];
	} else {
		NSMutableString *postCodes = [NSMutableString stringWithString:@"Nearby post codes are:\n\n"];
		for (int i = 0 ; i < [[dictionary objectForKey:@"postalCodes"] count] ; i++) {
			[postCodes appendFormat:@"%@ (%@)\n",
				[[[dictionary objectForKey:@"postalCodes"] objectAtIndex:i] objectForKey:@"postalCode"],
				 [[[dictionary objectForKey:@"postalCodes"] objectAtIndex:i] objectForKey:@"placeName"]];
		}
		postalLabel.text = postCodes;
	}
	
}


- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[myLM release];
    [super dealloc];
}

@end
