//
//  RootViewController.m
//  rssread
//
//  Created by Shannon Appelcline on 10/14/08.
//  Copyright __MyCompanyName__ 2008. All rights reserved.
//

#import "RootViewController.h"
#import "rssreadAppDelegate.h"


@implementation RootViewController

- (void)viewDidLoad {
    [super viewDidLoad];
	
	self.title = @"RSS Feeds";
	
	rssList = [[NSMutableArray alloc] initWithCapacity:1];
	
	NSString *paths = [[NSBundle mainBundle] resourcePath];
	NSString *xmlFile = [paths stringByAppendingPathComponent:@"rssfeeds.xml"];
	NSURL *xmlURL = [NSURL fileURLWithPath:xmlFile isDirectory:NO];
	
	NSXMLParser *firstParser = [[NSXMLParser alloc] initWithContentsOfURL:xmlURL];
	[firstParser setDelegate:self];
	[firstParser parse];
	
}

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName attributes:(NSDictionary *)attributeDict {
	
	if ([elementName compare:@"feed"] == NSOrderedSame) {
		
		[rssList addObject:[[NSDictionary alloc] initWithObjectsAndKeys:
							[attributeDict objectForKey:@"title"],@"title",
							[attributeDict objectForKey:@"url"],@"url",
							nil]];
		
	}
}

- (void)parserDidEndDocument:(NSXMLParser *)parser {
	
	[parser release];
	
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [rssList count];
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
    }
    
	cell.textLabel.text = [[rssList objectAtIndex:indexPath.row] objectForKey:@"title"];
	cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
	
	return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {

	rssViewController *nextController = 
	[[rssViewController alloc] initWithURL:
	 [[rssList objectAtIndex:indexPath.row] objectForKey:@"url"]];

	nextController.title = [[rssList objectAtIndex:indexPath.row] objectForKey:@"title"];
	
	[self.navigationController pushViewController:nextController animated:YES];
	
	[nextController release];
	
}




	
	/*
// Override to support editing the list
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/


/*
// Override to support conditional editing of the list
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support rearranging the list
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the list
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/

/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
}
*/

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}


- (void)dealloc {
	[rssList release];
	
    [super dealloc];
}


@end

