//
//  rssViewController.m
//  rssread
//
//  Created by Shannon Appelcline on 10/14/08.
//  Copyright 2008 __MyCompanyName__. All rights reserved.
//

#import "rssViewController.h"


@implementation rssViewController


- (id)initWithURL:(NSString *)url {
	if (self = [super init]) {
		feedList = [[NSMutableArray alloc] initWithCapacity:0];
		NSXMLParser *nextParser = [[NSXMLParser alloc] initWithContentsOfURL:
								   [NSURL URLWithString:url]];
		[nextParser setDelegate:self];
		[nextParser parse];		
    }
    return self;
}

- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName attributes:(NSDictionary *)attributeDict
{

	if ([elementName compare:@"item"] == NSOrderedSame) {
		currentItem = [[NSMutableDictionary alloc] initWithCapacity:0];		
	} else if (currentItem != NULL) {
		currentContents = [[NSMutableString alloc] initWithCapacity:0];
	}

}

- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string {
	if (currentContents && string) {
		[currentContents appendString:string];
	}
}

- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {

	if ([elementName compare:@"item"] == NSOrderedSame) {
		[feedList addObject:currentItem];
		[currentItem release];
	} else if (currentItem && currentContents) {
		[currentItem setObject:currentContents forKey:elementName];
		currentContents = nil;
		[currentContents release];
	}	
}

- (void)parserDidEndDocument:(NSXMLParser *)parser {

	[parser release];
}
 


/*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if (self = [super initWithStyle:style]) {
    }
    return self;
}
*/

/*
// Implement viewDidLoad to do additional setup after loading the view.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}


- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [feedList count];
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
    }

	if ([[feedList objectAtIndex:indexPath.row] objectForKey:@"title"]) {
		cell.textLabel.text = [[feedList objectAtIndex:indexPath.row]
					 objectForKey:@"title"];
	}
	if ([[feedList objectAtIndex:indexPath.row] objectForKey:@"link"]) {
		cell.accessoryType = UITableViewCellAccessoryDisclosureIndicator;
	}	
    return cell;
}

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {

	UIWebView *thisInfo = [[UIWebView alloc] init];
	[thisInfo loadRequest:[NSURLRequest requestWithURL:
						   [NSURL URLWithString:
							[[feedList objectAtIndex:indexPath.row]
							 objectForKey:@"link"]]]];
	thisInfo.scalesPageToFit = YES;
	
	UIViewController *thisVC = [[UIViewController alloc] init];
	thisVC.view = thisInfo;
	thisVC.title = [[feedList objectAtIndex:indexPath.row]
					  objectForKey:@"title"];

	[self.navigationController pushViewController:thisVC animated:YES];
	
	[thisInfo release];
	[thisVC release];
}

/*
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
    }
    if (editingStyle == UITableViewCellEditingStyleInsert) {
    }
}
*/

/*
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    return YES;
}
*/

/*
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/

/*
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    return YES;
}
*/


/*
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
}
*/
/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
}
*/
/*
- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
}
*/

- (void)dealloc {
	[feedList release];
    [super dealloc];
}


@end

