//
//  GKChatViewController.m
//  GKChat
//
//  Created by Brandon Trebitowski on 10/8/09.
//  Copyright RightSprite 2009. All rights reserved.
//

#import "GKChatViewController.h"

@implementation GKChatViewController

@synthesize sendTextField;
@synthesize chatTextArea;
@synthesize chatSession;

/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	chatPicker = [[GKPeerPickerController alloc] init];
	[chatPicker setDelegate:self];
	[chatPicker setConnectionTypesMask:(GKPeerPickerConnectionTypeNearby | GKPeerPickerConnectionTypeOnline)];
	peers = [[NSMutableArray alloc] init];
}

-(IBAction) connect:(id)sender {
	[chatPicker show];
}

#pragma mark GKPeerPickerControllerDelegate methods

- (void)peerPickerController:(GKPeerPickerController *)picker didSelectConnectionType:(GKPeerPickerConnectionType)type{			 
	
}

- (void)peerPickerControllerDidCancel:(GKPeerPickerController *)picker{
	NSLog(@"The connection was cancelled");
}

- (void)peerPickerController:(GKPeerPickerController *)picker didConnectPeer:(NSString *)peerID toSession:(GKSession *)session{
	
    self.chatSession = session;

    self.chatSession.delegate = self;
    [self.chatSession setDataReceiveHandler:self withContext:nil];
    [chatPicker dismiss];

}

- (GKSession *)peerPickerController:(GKPeerPickerController *)picker sessionForConnectionType:(GKPeerPickerConnectionType)type{
	
	GKSession* session = [[GKSession alloc] initWithSessionID:@"wbSession" displayName:@"iPhone" sessionMode:GKSessionModePeer];
    [session autorelease];
	return session;
}

#pragma mark GKSessionDelegate Methods

- (void)session:(GKSession *)session peer:(NSString *)peerID didChangeState:(GKPeerConnectionState)state
{
    switch (state)
    {
        case GKPeerStateConnected:
			[peers addObject:peerID];
			[chatTextArea setText:[NSString stringWithFormat:@"%@ has joined the chat.\n",[session displayName]]];
			break;
        case GKPeerStateDisconnected:
			[peers removeObject:peerID];
			NSString * text = [chatTextArea text];
			[chatTextArea setText:[NSString stringWithFormat:@"%@%@ has left the chat.\n",text,[session displayName]]];
			break;
    }
}

#pragma mark Send and Recieve methods
- (void) receiveData:(NSData *)data fromPeer:(NSString *)peer inSession: (GKSession *)session context:(void *)context
{
	NSString * string = [[NSString alloc] initWithData:data encoding:NSASCIIStringEncoding];
	NSString * text   = [chatTextArea text];
	[chatTextArea setText:[NSString stringWithFormat:@"%@%@: %@\n",text,[session displayName],string]];
}

-(IBAction) send:(id)sender {
	NSData * data = [[sendTextField text] dataUsingEncoding:NSASCIIStringEncoding];
	[chatSession sendData:data toPeers:peers withDataMode:GKSendDataReliable error:nil];
	NSString * text   = [chatTextArea text];
	[chatTextArea setText:[NSString stringWithFormat:@"%@Me: %@\n",text,[sendTextField text]]];
	[sendTextField setText:@""];
	[sendTextField resignFirstResponder];
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	chatTextArea  = nil;
	sendTextField = nil;
}


- (void)dealloc {
    [super dealloc];
	[chatTextArea release];
	[sendTextField release];
	[chatSession release];
	[chatPicker release];
}

@end
