//
//  GKTennisViewController.h
//  GKTennis
//
//  Created by Brandon Trebitowski on 10/14/09.
//  Copyright RightSprite 2009. All rights reserved.
//

#import <UIKit/UIKit.h>
#import <GameKit/GameKit.h>

typedef struct {
	CGPoint ballPosition;
	CGPoint paddlePosition[2];
	CGPoint ballVelocity;
	int score[2];
} gameInfo;

typedef enum {
	kStateStartGame,
	kStatePicker,
	kStateMultiplayer,
	kStateMultiplayerCointoss,
	kStateGameOver
} gameStates;

typedef enum {
	NETWORK_COINTOSS,				
	NETWORK_MOVE_EVENT,			
	NETWORK_BALL_MOVE_EVENT,
	NETWORK_GAME_STATUS
} packetCodes;

typedef enum {
	kServer,
	kClient
} gameNetwork;

@interface GKTennisViewController : UIViewController<GKPeerPickerControllerDelegate,GKSessionDelegate> {
	// Interface
	IBOutlet UIView * paddle_1;
	IBOutlet UIView * paddle_2;
	IBOutlet UIImageView * ball;
	
	IBOutlet UILabel * score_1_label;
	IBOutlet UILabel * score_2_label;
	IBOutlet UILabel * game_label;
	
	// Game logic
	
	NSInteger	gameState;
	NSInteger	peerStatus;
	
	gameInfo	gameStatus;
	BOOL		justCollided;
	
	// networking
	GKSession		*gameSession;
	int				gameUniqueID;
	int				gamePacketNumber;
	NSString		*gamePeerId;

}

@property(nonatomic, retain) IBOutlet UIView * paddle_1;
@property(nonatomic, retain) IBOutlet UIView * paddle_2;
@property(nonatomic, retain) IBOutlet UIImageView * ball;

@property(nonatomic, retain) IBOutlet UILabel * score_1_label;
@property(nonatomic, retain) IBOutlet UILabel * score_2_label;
@property(nonatomic, retain) IBOutlet UILabel * game_label;

@property(nonatomic) NSInteger		gameState;
@property(nonatomic) NSInteger		peerStatus;

@property(nonatomic, retain) GKSession	 *gameSession;
@property(nonatomic, copy)	 NSString	 *gamePeerId;


- (void) showPicker;
- (void)invalidateSession:(GKSession *)session;
- (void)sendNetworkPacket:(GKSession *)session packetID:(int)packetID withData:(void *)data ofLength:(int)length reliable:(BOOL)howtosend;
- (void) resetBall;
@end

