//
//  AnnotateMeViewController.m
//  AnnotateMe
//
//  Created by Brandon Trebitowski on 12/1/09.
//  Copyright RightSprite 2009. All rights reserved.
//

#import "AnnotateMeViewController.h"

@implementation AnnotateMeViewController

@synthesize mapView;

- (IBAction) dropPin:(id) sender {
	MKReverseGeocoder * geoCoder = [[MKReverseGeocoder alloc] initWithCoordinate:mapView.centerCoordinate];
	[geoCoder setDelegate:self];
	[geoCoder start];
}

- (void)reverseGeocoder:(MKReverseGeocoder *)geocoder didFindPlacemark:(MKPlacemark *)placemark {
	[mapView addAnnotation:placemark];
}

- (void)reverseGeocoder:(MKReverseGeocoder *)geocoder didFailWithError:(NSError *)error {
	UIAlertView * alert = [[UIAlertView alloc] initWithTitle:@"Error" 
													 message:@"Unable to get address" 
													delegate:nil 
										   cancelButtonTitle:@"OK" 
										   otherButtonTitles:nil];
	[alert show];
	[alert release];
}

- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id <MKAnnotation>)annotation {
	MKPinAnnotationView *aView = [[MKPinAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:@"location"];
	aView.animatesDrop = YES;
	return aView;
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
