//
//  CustomAnnotationViewController.m
//  CustomAnnotation
//
//  Created by Brandon Trebitowski on 12/2/09.
//  Copyright RightSprite 2009. All rights reserved.
//

#import "CustomAnnotationViewController.h"
#import "MyAnnotation.h"
#import "MyAnnotationView.h"

@implementation CustomAnnotationViewController

@synthesize mapView;


/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	CLLocationCoordinate2D coords;
	coords.latitude  = 37.331689;
	coords.longitude = -122.030731;
	MKCoordinateSpan span = MKCoordinateSpanMake(0.011209, 0.22597);
	
	MKCoordinateRegion region = MKCoordinateRegionMake(coords, span);
	[mapView setRegion:region animated:YES];	
	
	CLLocationCoordinate2D appleCoords;
	appleCoords.latitude = 37.331689;
	appleCoords.longitude = -122.030731;
	MyAnnotation * apple = [[MyAnnotation alloc] initWithCoords:appleCoords andType:Apple];
	[apple setTitle:@"Apple Inc."];
	[apple setSubtitle:@"Cupertino, CA"];
	[mapView addAnnotation:apple];
	[apple release];
	
	CLLocationCoordinate2D googleCoords;
	googleCoords.latitude = 37.421793;
	googleCoords.longitude = -122.084434;
	MyAnnotation * google = [[MyAnnotation alloc] initWithCoords:googleCoords andType:Google];
	[google setTitle:@"Google Inc."];
	[google setSubtitle:@"Mountain View, CA"];
	[mapView addAnnotation:google];
	[google release];
}

- (MKAnnotationView *)mapView:(MKMapView *)mapView viewForAnnotation:(id <MKAnnotation>)annotation {
	NSLog(@"checking annotation");
	MyAnnotationView *aView = [[MyAnnotationView alloc] initWithAnnotation:annotation reuseIdentifier:@"location"];
	[aView setEnabled:YES];
	[aView setCanShowCallout:YES];
	return aView;
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}

@end
