//
//  MyAnnotation.h
//  CustomAnnotation
//
//  Created by Brandon Trebitowski on 12/3/09.
//  Copyright 2009 RightSprite. All rights reserved.
//

#import <MapKit/MapKit.h>

typedef enum AnnotationType {
	Apple,
	Google
} AnnotationType;

@interface MyAnnotation : NSObject<MKAnnotation> {
	CLLocationCoordinate2D coordinate;
	NSString * title;
	NSString * subtitle;
	AnnotationType annotationType;
}

@property (nonatomic, readonly) CLLocationCoordinate2D coordinate;
@property (nonatomic, retain) NSString * title;
@property (nonatomic, retain) NSString * subtitle;
@property (nonatomic) AnnotationType annotationType;

- (id)initWithCoords:(CLLocationCoordinate2D) coords andType:(AnnotationType) type;

@end
